Skip to content

Latest commit

 

History

History
56 lines (34 loc) · 1.79 KB

877-Stone Game.md

File metadata and controls

56 lines (34 loc) · 1.79 KB

题目描述

https://leetcode.com/problems/stone-game/

Alex and Lee play a game with piles of stones. There are an even number of piles arranged in a row, and each pile has a positive integer number of stones piles[i].

The objective of the game is to end with the most stones. The total number of stones is odd, so there are no ties.

Alex and Lee take turns, with Alex starting first. Each turn, a player takes the entire pile of stones from either the beginning or the end of the row. This continues until there are no more piles left, at which point the person with the most stones wins.

Assuming Alex and Lee play optimally, return True if and only if Alex wins the game.

Example 1:

Input: [5,3,4,5]
Output: true

Explanation: 
Alex starts first, and can only take the first 5 or the last 5.
Say he takes the first 5, so that the row becomes [3, 4, 5].
If Lee takes 3, then the board is [4, 5], and Alex takes 5 to win with 10 points.
If Lee takes the last 5, then the board is [3, 4], and Alex takes 4 to win with 9 points.
This demonstrated that taking the first 5 was a winning move for Alex, so we return true.
 

Note:

2 <= piles.length <= 500
piles.length is even.
1 <= piles[i] <= 500
sum(piles) is odd.

Follow-up:

  • What if piles.length can be odd?
  • What if we want to know exactly the diffenerce of score?

思路-2D DP

参考:https://leetcode.com/problems/stone-game/discuss/154610/C%2B%2BJavaPython-DP-or-Just-return-true

dp[i][j]表示在i到j的石头堆里,比对手取得更多石头的最大数

Alex先手,可以选f[i]和f[j]:

  • 如果选f[i],对手Lee的选择是dp[i+1][j],因此Alex的结果是f[i] - dp[i+1][j]
  • 如果选f[j],同理Alex的结果是f[j] - dp[i][j-1]

因此DP公式为: dp[i][i] = f[i] dp[i][j] = max(f[i]-dp[i+1][j], f[j]-dp[i][j-1])